from sklearn.ensemble import RandomForestClassifier
from sklearn.linear_model import RidgeClassifier, LogisticRegression
from sklearn.svm import SVC
import pandas as pd
from utils import test_watermark_sklearn
from warnings import simplefilter

simplefilter(action='ignore', category=UserWarning)

if __name__ == '__main__':
    # Loading classification data
    df = pd.read_csv('./data/malware_detection.csv')
    X = df.drop(["Label"], axis=1)
    y = df['Label'].replace('malicious', 0)\
                   .replace('non-malicious', 1).values

    # Random Forest Classifier
    print('RANDOM FOREST CLASSIFIER\n')
    base_model = RandomForestClassifier(max_depth=1000, random_state=42)
    test_watermark_sklearn(X, y, base_model)

    # SVC
    print('\n\nSVC\n')
    base_model = SVC(gamma=10, C=1)
    test_watermark_sklearn(X, y, base_model)

    # Ridge Classifier
    print('\n\nRidgeClassifier\n')
    base_model = RidgeClassifier(alpha=.5)
    test_watermark_sklearn(X, y, base_model)

    # Logistic Regression
    print('\n\nLogistic Regression\n')
    base_model = LogisticRegression()
    test_watermark_sklearn(X, y, base_model)
